# If the data weren't generated before of number of warehouses has changed - generate
regenerate="NO"
dbt2_tmpdir=$TOP_DIR/var/dbt2

variables_to_regenerate="dbt2_number_of_warehouses dbt2_storage_engine"

if [ $rebuild_db_on_mysql_change = "YES" ]
then
        variables_to_regenerate="$variables_to_regenerate mysql_server"
fi

# Check if any of $variables_to_regenerate has changed
for v in $variables_to_regenerate
do
        if ! test -f $TOP_DIR/var/$v
        then
                regenerate="YES"
        else # the file $TOP_DIR/var/$v exists
                eval a=\$$v
                if [ "$a" != `cat $TOP_DIR/var/$v` ]
                then
                        regenerate="YES"
                fi
        fi
done

if [ "$regenerate" = "YES" ]
then
        # Save current values of variables to regenerate
        for v in $variables_to_regenerate
        do
                eval a=\$$v
                echo "$a" > $TOP_DIR/var/$v
        done

        rm -rf $dbt2_tmpdir && mkdir -p $dbt2_tmpdir
        $TOP_DIR/benchmarks/dbt2/bin/datagen -w $dbt2_number_of_warehouses -d $dbt2_tmpdir --mysql
        run_database_server
        $TOP_DIR/benchmarks/dbt2/scripts/mysql/build_db.sh -f $dbt2_tmpdir -e "$dbt2_storage_engine" -s ${mysql_socket} -v
        stop_database_server
	rm -rf $dbt2_tmpdir
	mkdir -p $TOP_DIR/var/backup
	echo "Backing up generated data"
        cp -R $mysql_datadir/* $TOP_DIR/var/backup/
else
        restore_data
fi

