SYSBENCH="$TOP_DIR/benchmarks/sysbench/bin/sysbench"
batch_arg=""
if [ "$sb_batch" = "YES" ]
then
	batch_arg="--batch --batch-delay=${sb_batch_delay}"
fi
case "$sb_test" in
	"cpu")
	SYSBENCH_ARGS="${batch_arg} \
		--num-threads=${sb_num_threads} \
		--max-requests=${sb_max_requests} \
		--max-time=${sb_max_time} \
		--thread-stack-size=${sb_thread_stack_size} \
		--init-rng=${sb_init_rng} \
		--validate=${sb_validate} \
		--test=$sb_test \
		--cpu-max-prime=${sb_cpu_max_prime}"
	;;
	"threads")
	SYSBENCH_ARGS="${batch_arg} \
		--num-threads=${sb_num_threads} \
		--max-requests=${sb_max_requests} \
		--max-time=${sb_max_time} \
		--thread-stack-size=${sb_thread_stack_size} \
		--init-rng=${sb_init_rng} \
		--validate=${sb_validate} \
		--test=$sb_test \
		--num-threads=${sb_num_threads} \
		--thread-yields=${sb_thread_yields} \
		--thread-locks=${sb_thread_locks}"
	;;
	"mutex")
	SYSBENCH_ARGS="${batch_arg} \
		--num-threads=${sb_num_threads} \
		--max-requests=${sb_max_requests} \
		--max-time=${sb_max_time} \
		--thread-stack-size=${sb_thread_stack_size} \
		--init-rng=${sb_init_rng} \
		--validate=${sb_validate} \
		--test=$sb_test \
		--mutex-num=${sb_mutex_num} \
		--mutex-locks=${sb_mutex_locks} \
		--mutex-loops=${sb_mutex_loops}"
	;;
	"memory")
	SYSBENCH_ARGS="${batch_arg} \
		--num-threads=${sb_num_threads} \
		--max-requests=${sb_max_requests} \
		--max-time=${sb_max_time} \
		--thread-stack-size=${sb_thread_stack_size} \
		--init-rng=${sb_init_rng} \
		--validate=${sb_validate} --test=$sb_test \
		--memory-block-size=${sb_memory_block_size} \
		--memory-scope=${sb_memory_scope} \
		--memory-total-size=${sb_memory_total_size} \
		--memory-oper=${sb_memory_oper}"
	;;
	"fileio")
	SYSBENCH_ARGS="${batch_arg} \
		--num-threads=${sb_num_threads} \
		--max-requests=${sb_max_requests} \
		--max-time=${sb_max_time} \
		--thread-stack-size=${sb_thread_stack_size} \
		--init-rng=${sb_init_rng} \
		--validate=${sb_validate} \
		--test=$sb_test \
		--file-num=${sb_file_num} \
		--file-block-size=${sb_file_block_size} \
		--file-total-size=${sb_file_total_size} \
		--file-test-mode=${sb_file_test_mode} \
		--file-io-mode=${sb_file_io_mode} \
		--file-async-backlog=${sb_file_async_backlog} \
		--file-extra-flags=${sb_file_extra_flags} \
		--file-fsync-freq=${sb_file_fsync_freq} \
		--file-fsync-all=${sb_file_fsync_all} \
		--file-fsync-end=${sb_file_fsync_end} \
		--file-fsync-mode=${sb_file_fsync_mode} \
		--file-merged-requests=${sb_file_merged_requests} \
		--file-rw-ratio=${sb_file_rw_ratio}"
	;;
	"oltp")
	SYSBENCH_ARGS="${batch_arg} \
		--num-threads=${sb_num_threads} \
		--max-requests=${sb_max_requests} \
		--max-time=${sb_max_time} \
		--thread-stack-size=${sb_thread_stack_size} \
		--init-rng=${sb_init_rng} \
		--validate=${sb_validate} \
		--test=$sb_test \
		--oltp-test-mode=${sb_oltp_test_mode} \
                --oltp-sp-name=${sb_oltp_sp_name} \
		--oltp-read-only=${sb_oltp_read_only} \
                --oltp-skip-trx=${sb_oltp_skip_trx} \
		--oltp-range-size=${sb_oltp_range_size} \
		--oltp-point-selects=${sb_oltp_point_selects} \
		--oltp-simple-ranges=${sb_oltp_simple_ranges} \
		--oltp-sum-ranges=${sb_oltp_sum_ranges} \
		--oltp-order-ranges=${sb_oltp_order_ranges} \
		--oltp-distinct-ranges=${sb_oltp_distinct_ranges} \
		--oltp-index-updates=${sb_oltp_index_updates} \
		--oltp-non-index-updates=${sb_oltp_non_index_updates} \
		--oltp-nontrx-mode=${sb_oltp_nontrx_mode} \
		--oltp-connect-delay=${sb_oltp_connect_delay} \
		--oltp-user-delay-min=${sb_oltp_user_delay_min} \
		--oltp-user-delay-max=${sb_oltp_user_delay_max} \
		--oltp-table-name=${sb_oltp_table_name} \
		--oltp-table-size=${sb_oltp_table_size} \
		--oltp-dist-type=${sb_oltp_dist_type} \
		--oltp-dist-pct=${sb_oltp_dist_pct} \
		--oltp-dist-res=${sb_oltp_dist_res} \
		--db-ps-mode=${sb_db_ps_mode} \
		--mysql-host=${sb_mysql_host} \
		--mysql-port=${sb_mysql_port} \
		--mysql-socket=${sb_mysql_socket} \
		--mysql-user=${sb_mysql_user} \
		--mysql-password=${sb_mysql_password} \
		--mysql-db=${sb_mysql_db} \
		--mysql-table-engine=${sb_mysql_table_engine} \
		--myisam-max-rows=${sb_myisam_max_rows}"
	;;
esac

if test -x "$SYSBENCH"
then
	vlog "Running: $SYSBENCH $SYSBENCH_ARGS run"
	"$SYSBENCH" $SYSBENCH_ARGS run > "${results_dir}/sysbench.out"
	if [ $sb_test = "fileio" ]
	then
		"$SYSBENCH" $SYSBENCH_ARGS cleanup
	fi
	if [ $sb_test = "oltp" ] && [ "$restart_mysqld" = "YES" ]
	then
		"$SYSBENCH" $SYSBENCH_ARGS cleanup
	fi
fi

