
regenerate="NO"

# If these variables change - regenerate data
variables_to_regenerate="tpcc_warehouses tpcc_db"

if [ $rebuild_db_on_mysql_change = "YES" ]
then
	variables_to_regenerate="$variables_to_regenerate mysql_server"
fi

# Check if any of $variables_to_regenerate has changed
for v in $variables_to_regenerate
do
	if ! test -f $TOP_DIR/var/$v
	then
		regenerate="YES"
	else # the file $TOP_DIR/var/$v exists
		eval a=\$$v
		if [ "$a" != `cat $TOP_DIR/var/$v` ]
		then
			regenerate="YES"
		fi
	fi
done

if [ "$regenerate" = "YES" ]
then
	# Save current values of variables to regenerate
	for v in $variables_to_regenerate
	do
		eval a=\$$v
		echo "$a" > $TOP_DIR/var/$v
	done
        run_database_server
	$MYSQL $MYSQL_ARGS -e "DROP DATABASE IF EXISTS $tpce_database"
	$MYSQL $MYSQL_ARGS -e "CREATE DATABASE $tpce_database"
	# Load data into MySQL
	cd $TOP_DIR/benchmarks/tpcc/scripts
	for i in create_table.sql add_fkey_idx.sql
	do	
		echo "Loading $i"
		echo "$MYSQL $MYSQL_ARGS $tpcc_db < $TOP_DIR/benchmarks/tpcc/scripts/$i"
		$MYSQL $MYSQL_ARGS $tpcc_db < $TOP_DIR/benchmarks/tpcc/scripts/$i
	done
	echo "Running $TOP_DIR/benchmarks/tpcc/bin/tpcc_load $tpcc_server $tpcc_db $tpcc_user $tpcc_password $tpcc_warehouses"
	$TOP_DIR/benchmarks/tpcc/bin/tpcc_load $tpcc_server $tpcc_db $tpcc_user $tpcc_password $tpcc_warehouses
        stop_database_server
	cd $TOP_DIR
	echo "Backing up generated data"
	mkdir -p $TOP_DIR/var/backup
        cp -R $mysql_datadir/* $TOP_DIR/var/backup/
else
        restore_data
fi

