
regenerate="NO"

# If these variables change - regenerate data
variables_to_regenerate="tpce_customer_ordinal_position \
	tpce_number_of_customers_instance \
	tpce_number_of_customers_database \
	tpce_scale_factor \
	tpce_number_of_workdays \
	tpce_type_of_load \
	tpce_flat_file_output_mode \
	tpce_generate_all \
	tpce_generate_fixed_size \
	tpce_generate_scaling_growing \
	tpce_generate_scaling \
	tpce_generate_growing \
	tpce_disable_caching \
	tpce_database"


if [ $rebuild_db_on_mysql_change = "YES" ]
then
        variables_to_regenerate="$variables_to_regenerate mysql_server"
fi

# Check if any of $variables_to_regenerate has changed
for v in $variables_to_regenerate
do
	if ! test -f $TOP_DIR/var/$v
	then
		regenerate="YES"
	else # the file $TOP_DIR/var/$v exists
		eval a=\$$v
		if [ "$a" != `cat $TOP_DIR/var/$v` ]
		then
			regenerate="YES"
		fi
	fi
done

if [ "$regenerate" = "YES" ]
then
        rm -rf $tpce_flat_out && mkdir -p $tpce_flat_out
	EGenLoader_ARGS="-b $tpce_customer_ordinal_position \
                -c $tpce_number_of_customers_instance \
                -t $tpce_number_of_customers_database \
                -f $tpce_scale_factor \
                -w $tpce_number_of_workdays \
                -i $tpce_flat_in \
                -l $tpce_type_of_load \
                -m $tpce_flat_file_output_mode \
                -o $tpce_flat_out"
	if [ "$tpce_generate_all" = "YES" ] ; then EGenLoader_ARGS="${EGenLoader_ARGS} -x"; fi
	if [ "$tpce_generate_fixed_size" = "YES" ] ; then EGenLoader_ARGS="${EGenLoader_ARGS} -xf"; fi
	if [ "$tpce_generate_scaling_growing" = "YES" ] ; then EGenLoader_ARGS="${EGenLoader_ARGS} -xd"; fi
	if [ "$tpce_generate_scaling" = "YES" ] ; then EGenLoader_ARGS="${EGenLoader_ARGS} -xs"; fi
	if [ "$tpce_generate_growing" = "YES" ] ; then EGenLoader_ARGS="${EGenLoader_ARGS} -xg"; fi
	if [ "$tpce_disable_caching" = "YES" ] ; then EGenLoader_ARGS="${EGenLoader_ARGS} -g"; fi
	vlog "Running $TOP_DIR/benchmarks/tpce/bin/EGenLoader ${EGenLoader_ARGS}"
	$TOP_DIR/benchmarks/tpce/bin/EGenLoader ${EGenLoader_ARGS}
	
	# Save current values of variables to regenerate
	for v in $variables_to_regenerate
	do
		eval a=\$$v
		echo "$a" > $TOP_DIR/var/$v
	done
        run_database_server
	$MYSQL $MYSQL_ARGS -e "DROP DATABASE IF EXISTS $tpce_database"
	$MYSQL $MYSQL_ARGS -e "CREATE DATABASE $tpce_database"
	# Load data into MySQL
	cd $tpce_flat_out
	for i in 1_create_table.sql 2_load_data.sql 3_create_fk.sql 4_create_index.sql 5_create_sequence.sql
	do	
		vlog "Loading $i"
		vlog "$MYSQL $MYSQL_ARGS $tpce_database < $TOP_DIR/benchmarks/tpce/scripts/$i"
		$MYSQL $MYSQL_ARGS $tpce_database < $TOP_DIR/benchmarks/tpce/scripts/$i
	done
        stop_database_server
	# Remove data to save some space
	rm -rf $tpce_flat_out
	vlog "Backing up generated data"
	mkdir -p $TOP_DIR/var/backup
        cp -R $mysql_datadir/* $TOP_DIR/var/backup/
else
        restore_data
fi

