
# Start appCache if needed
if [ $tpcw_start_cache = "YES" ]
then
	appCache_ARGS="--host ${tpcw_cache_host} \
		--dbname ${tpcw_database} \
		--username ${tpcw_user} \
		--password ${tpcw_password} \
		--port ${tpcw_cache_port} \
		--db_connection ${tpcw_cache_connections} \
		--item_count ${tpcw_items} \
		--output_path $results_dir/${tpcw_output_path} "
	if [ $tpcw_sanity_check = "YES" ]
	then
		appCache_ARGS="$appCache_ARGS --sanity_check"
	fi
	echo "Running $TOP_DIR/benchmarks/tpcw/bin/appCache $appCache_ARGS"
	$TOP_DIR/benchmarks/tpcw/bin/appCache $appCache_ARGS
fi 

# start appServer if needed
if [ $tpcw_start_server = "YES" ]
then
	appServer_ARGS="--host ${tpcw_server_name} \
		--dbname ${tpcw_database} \
		--username ${tpcw_user} \
		--password ${tpcw_password} \
		--server_port ${tpcw_server_port} \
		--db_connection ${tpcw_server_connections} \
		--txn_q_size ${tpcw_txn_q_size} \
		--txn_array_size ${tpcw_txn_array_size} \
		--item_count ${tpcw_items} \
		--output_path $results_dir/${tpcw_output_path}"
	if [ $tpcw_start_cache = "YES" ]
	then
		appServer_ARGS="$appServer_ARGS --access_cache  \
			--cache_host ${tpcw_cache_host} \
			--cache_port ${tpcw_cache_port}"
	fi
	echo "Running $TOP_DIR/benchmarks/tpcw/bin/appServer $appServer_ARGS"
	$TOP_DIR/benchmarks/tpcw/bin/appServer $appServer_ARGS
fi


dbdriver_ARGS="--item_count ${tpcw_items} \
        --customer_count ${tpcw_eus} \
        --emulated_users ${tpcw_emulated_users} \
        --rampup_rate ${tpcw_rampup_rate} \
        --think_time ${tpcw_think_time} \
        --duration ${tpcw_duration} \
        --output_path $results_dir/${tpcw_output_path}"

if [ $tpcw_start_server = "NO" ] 
then
	dbdriver_ARGS="$dbdriver_ARGS \
		--access_direct \
		--dbhost ${tpcw_host} \
		--dbname ${tpcw_database}"
else
	dbdriver_ARGS="$dbdriver_ARGS \
                --server_name ${tpcw_server_name} \
        --port ${tpcw_server_port}"
fi

if [ $tpcw_start_cache="YES" ]
then
	dbdriver_ARGS="$dbdriver_ARGS  \
		--cache_host ${tpcw_cache_host} \
        	--cache_port ${tpcw_cache_port} \
"
fi

echo "Running $TOP_DIR/benchmarks/tpcw/bin/dbdriver $dbdriver_ARGS"
$TOP_DIR/benchmarks/tpcw/bin/dbdriver $dbdriver_ARGS > $results_dir/tpcw.out
