#!/usr/bin/env bash
#!/bin/bash -x
results=$1

# FIXME: a more pretty options processing should be implemented

echo "Enter export ENABLE_ERRORS=YES if you need them on graphs"

if [ -z $results ] || ! [ -d $results ]
then
	echo "Usage: $0 <directory with results>"
	exit -1
fi

TOP_DIR=$results/0
var_file="var/chart_var.sh"

if test -f $TOP_DIR/0/config.sh
then
	source $TOP_DIR/0/config.sh
	config=$TOP_DIR/0/config.sh
else
	echo "There is no '$TOP_DIR/0/config.sh'. Is the '$results' wrong directory?"
	exit -1
fi
source chart.conf.sh
source statistik.sh

# Remove old files
rm -f *.dat
rm -f *.png
rm -f *.gplot
rm -f $var_file

function get_n_vars {
inv=1
while true
do
        var_name="var${inv}"
        eval xt=\$$var_name
        if test -z $xt
        then
                break
        fi
        let inv=$inv+1
done
echo $(($inv - 1))
}


echo "source $TOP_DIR/0/config.sh" >> $var_file
echo "oldIFS=\$IFS" >> $var_file
echo "newIFS=\",\"" >> $var_file
echo "IFS=\$newIFS" >> $var_file
echo "titles=\"\"" >> $var_file

n_vars=`get_n_vars`
# Count # of variables in a title
i=1
intend=""
vars_in_title=""
while [ $i -le $n_vars ]
do
	echo "${intend}for v$i in \$var${i}_range" >> $var_file
	echo "${intend}do" >> $var_file
	intend=$intend"	";
	# meanwhile find out which vars are in $title
	title_count_in_config=`grep title chart.conf.sh | grep -v "^v" | wc -l`
	if [ $title_count_in_config -gt 1 ]
	then
		echo "WARNING: There are $title_count_in_config titles in chart.conf.sh. Must be one."
	fi
	if [ "xxx`grep title chart.conf.sh | grep -v "^v" | grep "\\$v$i"`" != "xxx" ]
	then 
		vars_in_title="$i $vars_in_title"
	fi
	let i=$i+1
done

echo "${intend}IFS=\$oldIFS" >> $var_file
echo "${intend}source chart.conf.sh" >> $var_file
echo "${intend}chart=\`echo \$title | sed 's/[ \\t\\n\\r\/\\\(\)=#]/_/g'\`" >> $var_file
echo "${intend}if [ \"xxx\`echo \"\$titles\" | grep \"\$chart\"\`\" = \"xxx\" ] ; then titles=\"\$titles \$chart\" ; fi" >> $var_file
echo "${intend}IFS=\$newIFS" >> $var_file
i=1
while [ $i -le $n_vars ]
do
	intend=`echo "${intend}" | sed 's/\t//'`
	echo "${intend}done" >> $var_file
	let i=$i+1
done
echo "echo \"titles = \$titles\"" >> $var_file
echo "vars_in_title = $vars_in_title"


# The functiob get_value() reads results and counts errors
# Outputs average value and error in a format like this: 5.0 0.4
echo "
function get_value()
# \$1 - the directory with results
# #2 - the parameter the values of which you want to get
{

if test -d \$1
then
	case \"\$2\" in
	\"NOTPM\")
		vs=\"\"
		for itn in \$1/[0-9]*
		do
			vs=\"\$vs \`cat \$itn/dbt2.output/driver/results.out | grep NOTPM | cut -d \" \" -f 1\`\"
		done
		stat_ananlysis \"\$vs\"
		;;
	\"sysbench_tps\")
		vs=\"\"
		for itn in \$1/[0-9]*
		do
			vs=\"\$vs \`cat \$itn/sysbench.out | grep \"transactions:\" | sed 's/(/ /g' | awk '{ print \$3}'\`\"	
		done
		stat_ananlysis \"\$vs\"
		;;
	\"sysbench_rw_req\")
		vs=\"\"
		for itn in \$1/[0-9]*
		do
			vs=\"\$vs \`cat \$itn/sysbench.out | grep \"read/write requests:\" | sed 's/(/ /g' | awk '{ print \$4}'\`\"	
		done
		stat_ananlysis \"\$vs\"
		;;
	\"sysbench_other_operations\")
		vs=\"\"
		for itn in \$1/[0-9]*
		do
			vs=\"\$vs \`cat \$itn/sysbench.out | grep \"other operations:\" | sed 's/(/ /g' | awk '{ print \$4}'\`\"	
		done
		stat_ananlysis \"\$vs\"
		;;
	\"tpce_TpsE\")
		vs=\"\"
		for itn in \$1/[0-9]*
		do
			vs=\"\$vs \`cat \$itn/tpce.out | grep TpsE | awk '{ print \$1}'\`\"	
		done
		stat_ananlysis \"\$vs\"
		;;
	\"tpcc_TpmC\")
		vs=\"\"
		for itn in \$1/[0-9]*
		do
			vs=\"\$vs \`cat \$itn/tpcc.out | grep \" TpmC\" | awk '{ print \$1}'\`\"	
		done
		stat_ananlysis \"\$vs\"
		;;
	*)
		echo \"NULL\"
		;;
	esac
fi

}" >> $var_file
intend=""

for_grep="find $1 -name var.out"
for i in $vars_in_title
do
	echo "${intend}for v$i in \$var${i}_range" >> $var_file
	echo "${intend}do" >> $var_file
	intend=$intend"	";
	for_grep="$for_grep | xargs -n 1 grep \\\"var$i: \$var$i=\$v$i$\\\" -l"
done

echo "${intend}source chart.conf.sh" >> $var_file
echo "${intend}chart=\`echo \$title | sed 's/[ \\t\\n\\r\/\\\(\)=#]/_/g'\`" >> $var_file
echo "${intend}#echo \"$for_grep\"" >> $var_file
echo "${intend}a=\"\${x_values}_range\"" >> $var_file
echo "${intend}b=\"\${legend}_range\"" >> $var_file
echo "${intend}IFS=\"\$newIFS\"" >> $var_file
echo "${intend}eval x_range=\\\$\$a" >> $var_file
echo "${intend}# If b is empty then it's a static value" >> $var_file
echo "${intend}if test -z \`echo \$b | grep var[0-9]\`; then y_range=\"\${legend}\"; else eval y_range=\\\$\$b ; fi" >> $var_file
echo "${intend}echo \"set terminal png\" >> \${chart}.gplot" >> $var_file
echo "${intend}echo \"set output \\\"\${chart}.png\\\"\" >> \${chart}.gplot" >> $var_file
echo "${intend}echo \"set title \\\"\$title\\\"\" >> \${chart}.gplot" >> $var_file
echo "${intend}echo \"set ylabel \\\"\$y_axis\\\"\" >> \${chart}.gplot" >> $var_file
echo "${intend}echo \"set xlabel \\\"\$x_axis\\\"\" >> \${chart}.gplot" >> $var_file
echo "${intend}echo \"set yrange [0:]\" >> \${chart}.gplot" >> $var_file
echo "${intend}echo \"set key \$legend_place\" >> \${chart}.gplot" >> $var_file
echo "${intend}echo \"set datafile missing \\\"NaN\\\"\" >> \${chart}.gplot" >> $var_file
echo "${intend}if [ \"\$show_x_values\" = \"YES\" ] ; then echo \"set grid xtics\" >> \${chart}.gplot ; fi" >> $var_file
echo "${intend}if [ \"\$show_y_values\" = \"YES\" ] ; then echo \"set grid ytics\" >> \${chart}.gplot ; fi" >> $var_file
echo "${intend}xi=1" >> $var_file
echo "${intend}for x in \$x_range" >> $var_file
echo "${intend}do" >> $var_file
echo "${intend}	echo -n \"\$xi	\\\"\$x\\\"\" >> \${chart}.dat" >> $var_file
echo "${intend}	for y in \$y_range" >> $var_file
echo "${intend}	do" >> $var_file
echo "${intend}		echo \"(\$chart)x = \$x, y = \$y\"" >> $var_file
echo "${intend}		for_grep=\"$for_grep\"" >> $var_file
echo "${intend}		if test -z \`echo \$b | grep var[0-9]\`" >> $var_file
echo "${intend}		then" >> $var_file
echo "${intend}			for_grep=\"\$for_grep | xargs -n 1 grep \\\"\${x_values}.*=\$x$\\\" -l\"" >> $var_file
echo "${intend}		else" >> $var_file
echo "${intend}			for_grep=\"\$for_grep | xargs -n 1 grep \\\"\${x_values}.*=\$x$\\\" -l | xargs -n 1 grep \\\"\${legend}.*=\$y$\\\" -l\"" >> $var_file
echo "${intend}		fi" >> $var_file
echo "${intend}		#echo \"for_grep = \$for_grep\"" >> $var_file
echo "${intend}		res_files=\`eval \$for_grep\`" >> $var_file
echo "${intend}		if test -z \"\$res_files\"" >> $var_file
echo "${intend}		then" >> $var_file
echo "${intend}			v=\"NaN\"" >> $var_file
echo "${intend}		else" >> $var_file
echo "${intend}			IFS=\$oldIFS" >> $var_file
echo "${intend}			for id in \$res_files" >> $var_file
echo "${intend}			do" >> $var_file
echo "${intend}				if ! test -f \`dirname \$id\`/cursor" >> $var_file
echo "${intend}				then" >> $var_file
echo "${intend}					touch \`dirname \$id\`/cursor" >> $var_file
echo "${intend}					d_cur=\`dirname \$id\`" >> $var_file
echo "${intend}					d_cur=\`dirname \$d_cur\`" >> $var_file
echo "${intend}					v=\`get_value \$d_cur \$y_values\`" >> $var_file
echo "${intend}					break" >> $var_file
echo "${intend}				fi" >> $var_file
echo "${intend}			done" >> $var_file
echo "${intend}			IFS=\$newIFS" >> $var_file
echo "${intend}		fi" >> $var_file
echo "${intend}		echo -n \"	\$v\" >> \${chart}.dat" >> $var_file
echo "${intend}	done" >> $var_file
echo "${intend}	echo \"\" >> \${chart}.dat" >> $var_file
echo "${intend}	let xi=\$xi+1" >> $var_file
echo "${intend}done" >> $var_file

echo "${intend}a=\${legend}_range" >> $var_file
echo "${intend}if test -z \`echo \$a | grep var[0-9]\` ; then r=\${legend}; else eval r=\\\$\$a; fi" >> $var_file
echo "${intend}i=3" >> $var_file
echo "${intend}echo -n \"plot \" >> \${chart}.gplot" >> $var_file
echo "${intend}sep=\"\"" >> $var_file
echo "${intend}for l in \$r" >> $var_file
echo "${intend}do" >> $var_file
echo "${intend}	let ierr=\$i+1" >> $var_file
echo "${intend}	echo -n \"\${sep} '\${chart}.dat' using 1:\$i:\$ierr:xticlabels(2) title \\\"\$l\\\" with yerrorlines lw 2\" >> \${chart}.gplot" >> $var_file
echo "${intend}	let i=\$i+2" >> $var_file
echo "${intend}	sep=\",\"" >> $var_file
echo "${intend}done" >> $var_file
echo "${intend}echo \"\" >> \${chart}.gplot" >> $var_file

for i in $vars_in_title
do
	intend=`echo "${intend}" | sed 's/\t//'`
	echo "${intend}done" >> $var_file
done

source $var_file

IFS=$oldIFS
for i in `ls -1 *.gplot 2> /dev/null`
do
	gnuplot $i
done

find $results -name cursor | xargs -n 1 rm -f
if test -z $debug; then rm -f $var_file; fi

