/*
 * createSC.h 
 *
 * This file is released under the terms of the Artistic License.  Please see
 * the file LICENSE, included in this package, for details.
 *
 * Copyright (C) 2002 Mark Wong & Jenny Zhang &
 *                    Open Source Development Lab, Inc.
 * Copyright (C) 2005 Koji Fukui
 *                    Sumisho Computer Systems Corporation
 * Copyright (C) 2005 Masaki.Kuroda & Shuuichi Suzuki
 *                    UNIADEX, Ltd.
 */

#ifndef _createSC_H
#define _createSC_H

#include <interaction.h>

#define STMT_createSC_selCUST \
       "SELECT c_fname, c_lname, c_discount "\
       "FROM customer "\
       "WHERE c_id=%lld"

#ifdef ORACLE_ODBC
/* Oracle */
#define STMT_createSC_insSC1 \
       "INSERT INTO shopping_cart(sc_id, sc_c_id   , sc_date, "\
                                 "sc_c_fname, sc_c_lname, sc_c_discount) "\
       "VALUES ( %lld , %lld, CURRENT_TIMESTAMP , '%s', '%s', %lf ) ; "

#define STMT_createSC_insSC2 \
       "INSERT INTO shopping_cart(sc_id, sc_date) "\
       "VALUES ( %lld , CURRENT_TIMESTAMP ) "
#elif DB2_ODBC
/* DB2 */
#define STMT_createSC_insSC1 \
       "INSERT INTO shopping_cart(sc_id, sc_c_id   , sc_date, "\
                                 "sc_c_fname, sc_c_lname, sc_c_discount) "\
       "VALUES ( %lld , %lld, CURRENT TIMESTAMP , '%s', '%s', %lf ) ; "

#define STMT_createSC_insSC2 \
       "INSERT INTO shopping_cart(sc_id, sc_date) "\
       "VALUES ( %lld , CURRENT TIMESTAMP ) "
#else
/* PostgreSQL, MySQL */
#define STMT_createSC_insSC1 \
       "INSERT INTO shopping_cart(sc_id, sc_c_id   , sc_date, "\
                                 "sc_c_fname, sc_c_lname, sc_c_discount) "\
       "VALUES ( %lld , %lld, NOW() , '%s', '%s', %lf ) ; "

#define STMT_createSC_insSC2 \
       "INSERT INTO shopping_cart(sc_id, sc_date) "\
       "VALUES ( %lld , NOW() ) "
#endif

#ifdef MYSQL_ODBC
/* MySQL */
#define STMT_createSC_selInsVal_Pre \
        "UPDATE scid SET id=LAST_INSERT_ID(id+1)"
#define STMT_createSC_selInsVal \
        "select LAST_INSERT_ID()"

#elif ORACLE_ODBC
/* Oracle */
#define STMT_createSC_selInsVal \
        "select scid.nextval from DUAL"

#elif DB2_ODBC
/* DB2 */
#define STMT_createSC_selInsVal \
        "select next value for scid from SYSIBM.SYSDUMMY1"

#else
/* PostgreSQL */
#define STMT_createSC_selInsVal \
        "select nextval('scid')"
#endif

int createSC(struct db_context_t *odbcc,
             struct shopping_cart_t *data);

#endif /* _createSC_H */
