#ifndef _ODBC_WRAPPER_H
#define _ODBC_WRAPPER_H

#include <my_global.h>
#include <mysql.h>
#include <my_sys.h>

#include <sql.h>
#include <sqltypes.h>
#include <sqlext.h>

#ifdef __cplusplus
extern "C" {
#endif

enum MY_STATE { ST_UNKNOWN, ST_PREPARED, ST_PRE_EXECUTED, ST_EXECUTED };

typedef struct st_my_hdbc
{
    //ͥƥ֤³ƥ
    MYSQL* mysql;

    int connected; //³椫ɤΥե饰
} MY_HDBC;

typedef struct st_my_hstmt
{
    //ͥƥ֤PreparedStatementƥ
    MYSQL_STMT*   mysql_stmt;

    //MySQL ODBC 
    DYNAMIC_ARRAY params; //PrepareBindParameterդ뤿ɬ
    enum MY_STATE state;

    //¾ɬץСѿ
    int nColumns;
    int nParameters;
    MYSQL_RES*  meta_result;  /* PreparedStatement μ¹Է̤Υ᥿ǡǼ*/
    MYSQL_BIND* columnP;      /* ¹Է̥Х */
    MYSQL_BIND* paramP;       /* ѥ᡼Х */

    int prepared; //PrepareѤߤɤΥե饰
    int res_binded; //bind_resultѤߤɤΥե饰
} MY_HSTMT;

typedef struct st_param_bind
{
  SQLSMALLINT   SqlType,CType;
  void *        buffer;
  char *        pos_in_query,*value;
  SQLINTEGER    ValueMax;
  SQLINTEGER *  actual_len;
  SQLINTEGER    value_length;
  bool          alloced,used;
  bool          real_param_done;
} PARAM_BIND;

/*
#define SQL_UNKNOWN_TYPE        0
#define SQL_CHAR            1
#define SQL_NUMERIC         2
#define SQL_DECIMAL         3
#define SQL_INTEGER         4
#define SQL_SMALLINT        5
#define SQL_FLOAT           6
#define SQL_REAL            7
#define SQL_DOUBLE          8
#define SQL_DATETIME        9
#define SQL_VARCHAR        12

#define SQL_SUCCESS                0
#define SQL_SUCCESS_WITH_INFO      1
#define SQL_NO_DATA              100
#define SQL_ERROR                 (-1)

#define SQL_NTS                   (-3)
#define SQL_NTSL                  (-3L)

#define SQL_COMMIT          0
#define SQL_ROLLBACK        1

#define SQL_NULL_HENV       0
#define SQL_NULL_HDBC       0
#define SQL_NULL_HSTMT      0

#define SQL_HANDLE_ENV             1
#define SQL_HANDLE_DBC             2
#define SQL_HANDLE_STMT            3
#define SQL_HANDLE_DESC            4

#define SQL_NULL_HANDLE     0L
*/

#ifdef __cplusplus
}
#endif

SQLRETURN  SQL_API SQLConnect_DIRECT(SQLHDBC ConnectionHandle,
				SQLCHAR *ServerName, SQLSMALLINT NameLength1,
				SQLCHAR *DatabaseName, SQLSMALLINT NameLength4,
				SQLCHAR *UserName, SQLSMALLINT NameLength2,
				SQLCHAR *Authentication, SQLSMALLINT NameLength3);

#endif /* _ODBC_WRAPPER_H */
