#this script can be used to build the database

if test -z $TOP_DIR
then
        echo "TOP_DIR is undefined. define it by export TOP_DIR=\"benchwork top directory\""
        exit -1
fi

rm -rf $tpcw_path
mkdir -p $tpcw_path
echo "$TOP_DIR/benchmarks/tpcw/bin/datagen -d $tpcw_rdbms -i $tpcw_items -u $tpcw_eus -p $tpcw_path -T i -T c -T a -T d -T o"
$TOP_DIR/benchmarks/tpcw/bin/datagen -d $tpcw_rdbms -i $tpcw_items -u $tpcw_eus -p $tpcw_path -T i -T c -T a -T d -T o
cp $TOP_DIR/benchmarks/tpcw/scripts/country.data.sapdb $tpcw_path

DROP_DB="DROP DATABASE IF EXISTS ${tpcw_database}"
CREATE_DB="CREATE DATABASE ${tpcw_database}"

START="SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;"

STOP="SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;"

CREATE_TABLES="
--
-- Table structure for table \`address\`
--

DROP TABLE IF EXISTS \`address\`;
CREATE TABLE \`address\` (
  \`addr_id\` int(11) NOT NULL,
  \`addr_street1\` varchar(40) default NULL,
  \`addr_street2\` varchar(40) default NULL,
  \`addr_city\` varchar(30) default NULL,
  \`addr_state\` varchar(20) default NULL,
  \`addr_zip\` varchar(10) default NULL,
  \`addr_co_id\` smallint(5) default NULL,
  PRIMARY KEY  (\`addr_id\`)
) ENGINE=$tpcw_engine $tpcw_create_options;



--
-- Table structure for table \`author\`
--

DROP TABLE IF EXISTS \`author\`;
CREATE TABLE \`author\` (
  \`a_id\` int(11) NOT NULL,
  \`a_fname\` varchar(20) default NULL,
  \`a_lname\` varchar(20) default NULL,
  \`a_mname\` varchar(20) default NULL,
  \`a_dob\` date default NULL,
  \`a_bio\` text,
  PRIMARY KEY  (\`a_id\`)
) ENGINE=$tpcw_engine $tpcw_create_options;



--
-- Table structure for table \`cc_xacts\`
--

DROP TABLE IF EXISTS \`cc_xacts\`;
CREATE TABLE \`cc_xacts\` (
  \`cx_o_id\` int(11) NOT NULL default '0',
  \`cx_type\` varchar(10) default NULL,
  \`cx_num\` bigint(17) default NULL,
  \`cx_name\` varchar(31) default NULL,
  \`cx_expiry\` date default NULL,
  \`cx_auth_id\` varchar(15) default NULL,
  \`cx_xact_amt\` decimal(17,2) default NULL,
  \`cx_xact_date\` datetime NOT NULL,
  \`cx_co_id\` smallint(5) default NULL,
  PRIMARY KEY  (\`cx_o_id\`)
) ENGINE=$tpcw_engine $tpcw_create_options;

--
-- Table structure for table \`country\`
--

DROP TABLE IF EXISTS \`country\`;
CREATE TABLE \`country\` (
  \`co_id\` smallint(5) NOT NULL default '0',
  \`co_name\` varchar(50) default NULL,
  \`co_exchange\` decimal(12,6) default NULL,
  \`co_currency\` varchar(18) default NULL,
  PRIMARY KEY  (\`co_id\`)
) ENGINE=$tpcw_engine $tpcw_create_options;

--
-- Table structure for table \`customer\`
--

DROP TABLE IF EXISTS \`customer\`;
CREATE TABLE \`customer\` (
  \`c_id\` int(11) NOT NULL,
  \`c_uname\` varchar(20) default NULL,
  \`c_passwd\` varchar(20) default NULL,
  \`c_fname\` varchar(15) default NULL,
  \`c_lname\` varchar(15) default NULL,
  \`c_addr_id\` int(11) default NULL,
  \`c_phone\` varchar(16) default NULL,
  \`c_email\` varchar(50) default NULL,
  \`c_since\` date default NULL,
  \`c_last_visit\` date default NULL,
  \`c_login\` datetime NOT NULL,
  \`c_expiration\` datetime NOT NULL,
  \`c_discount\` decimal(5,2) default NULL,
  \`c_balance\` decimal(17,2) default NULL,
  \`c_ytd_pmt\` decimal(17,2) default NULL,
  \`c_birthdate\` date default NULL,
  \`c_data\` text,
  PRIMARY KEY  (\`c_id\`)
) ENGINE=$tpcw_engine $tpcw_create_options;

--
-- Table structure for table \`item\`
--

DROP TABLE IF EXISTS \`item\`;
CREATE TABLE \`item\` (
  \`i_id\` int(11) NOT NULL default '0',
  \`i_title\` varchar(60) default NULL,
  \`i_a_id\` int(11) default NULL,
  \`i_pub_date\` date default NULL,
  \`i_publisher\` varchar(60) default NULL,
  \`i_subject\` varchar(60) default NULL,
  \`i_desc\` text,
  \`i_related1\` int(11) default NULL,
  \`i_related2\` int(11) default NULL,
  \`i_related3\` int(11) default NULL,
  \`i_related4\` int(11) default NULL,
  \`i_related5\` int(11) default NULL,
  \`i_thumbnail\` int(9) default NULL,
  \`i_image\` int(9) default NULL,
  \`i_srp\` decimal(17,2) default NULL,
  \`i_cost\` decimal(17,2) default NULL,
  \`i_avail\` date default NULL,
  \`i_stock\` smallint(5) default NULL,
  \`i_isbn\` varchar(13) default NULL,
  \`i_page\` smallint(5) default NULL,
  \`i_backing\` varchar(15) default NULL,
  \`i_dimensions\` varchar(25) default NULL,
  PRIMARY KEY  (\`i_id\`)
) ENGINE=$tpcw_engine $tpcw_create_options;


--
-- Table structure for table \`order_line\`
--

DROP TABLE IF EXISTS \`order_line\`;
CREATE TABLE \`order_line\` (
  \`ol_id\` smallint(4) NOT NULL default '0',
  \`ol_o_id\` int(11) NOT NULL default '0',
  \`ol_i_id\` int(11) default NULL,
  \`ol_qty\` smallint(4) default NULL,
  \`ol_discount\` decimal(5,2) default NULL,
  \`ol_comments\` varchar(100) default NULL,
  PRIMARY KEY  (\`ol_o_id\`,\`ol_id\`)
) ENGINE=$tpcw_engine $tpcw_create_options;

--
-- Table structure for table \`orders\`
--

DROP TABLE IF EXISTS \`orders\`;
CREATE TABLE \`orders\` (
  \`o_id\` int(11) NOT NULL default '0',
  \`o_c_id\` int(11) default NULL,
  \`o_date\` datetime NOT NULL,
  \`o_sub_total\` decimal(17,2) default NULL,
  \`o_tax\` decimal(17,2) default NULL,
  \`o_total\` decimal(17,2) default NULL,
  \`o_ship_type\` varchar(10) default NULL,
  \`o_ship_date\` datetime NOT NULL,
  \`o_bill_addr_id\` int(11) default NULL,
  \`o_ship_addr_id\` int(11) default NULL,
  \`o_status\` varchar(15) default NULL,
  PRIMARY KEY  (\`o_id\`)
) ENGINE=$tpcw_engine $tpcw_create_options;

--
-- Table structure for table \`shopping_cart\`
--

DROP TABLE IF EXISTS \`shopping_cart\`;
CREATE TABLE \`shopping_cart\` (
  \`sc_id\` int(11) NOT NULL,
  \`sc_c_id\` int(11) default NULL,
  \`sc_date\` datetime NOT NULL,
  \`sc_sub_total\` decimal(17,2) default NULL,
  \`sc_tax\` decimal(17,2) default NULL,
  \`sc_ship_cost\` decimal(17,2) default NULL,
  \`sc_total\` decimal(17,2) default NULL,
  \`sc_c_fname\` varchar(15) default NULL,
  \`sc_c_lname\` varchar(15) default NULL,
  \`sc_c_discount\` decimal(5,2) default NULL,
  PRIMARY KEY  (\`sc_id\`)
) ENGINE=$tpcw_engine $tpcw_create_options;

--
-- Table structure for table \`shopping_cart_line\`
--

DROP TABLE IF EXISTS \`shopping_cart_line\`;
CREATE TABLE \`shopping_cart_line\` (
  \`scl_sc_id\` int(11) NOT NULL default '0',
  \`scl_i_id\` int(11) NOT NULL default '0',
  \`scl_qty\` smallint(4) default NULL,
  \`scl_cost\` decimal(17,2) default NULL,
  \`scl_srp\` decimal(17,2) default NULL,
  \`scl_title\` varchar(60) default NULL,
  \`scl_backing\` varchar(15) default NULL,
  PRIMARY KEY  (\`scl_sc_id\`,\`scl_i_id\`)
) ENGINE=$tpcw_engine $tpcw_create_options;

"

LOAD_DB="$START
LOAD DATA LOCAL INFILE \"$tpcw_path/address.data\" INTO TABLE address FIELDS TERMINATED BY \",\" OPTIONALLY ENCLOSED BY \"\"\"\";
LOAD DATA LOCAL INFILE \"$tpcw_path/author.data\" INTO TABLE author FIELDS TERMINATED BY \",\" OPTIONALLY ENCLOSED BY \"\"\"\";
LOAD DATA LOCAL INFILE \"$tpcw_path/cc_xacts.data\" INTO TABLE cc_xacts FIELDS TERMINATED BY \",\" OPTIONALLY ENCLOSED BY \"\"\"\";
LOAD DATA LOCAL INFILE \"$tpcw_path/country.data.sapdb\" INTO TABLE country FIELDS TERMINATED BY \",\" OPTIONALLY ENCLOSED BY \"\"\"\";
LOAD DATA LOCAL INFILE \"$tpcw_path/customer.data\" INTO TABLE customer FIELDS TERMINATED BY \",\" OPTIONALLY ENCLOSED BY \"\"\"\";
LOAD DATA LOCAL INFILE \"$tpcw_path/item.data\" INTO TABLE item FIELDS TERMINATED BY \",\" OPTIONALLY ENCLOSED BY \"\"\"\";
LOAD DATA LOCAL INFILE \"$tpcw_path/order_line.data\" INTO TABLE order_line FIELDS TERMINATED BY \",\" OPTIONALLY ENCLOSED BY \"\"\"\";
LOAD DATA LOCAL INFILE \"$tpcw_path/orders.data\" INTO TABLE orders FIELDS TERMINATED BY \",\" OPTIONALLY ENCLOSED BY \"\"\"\";
$STOP
"
	
CREATE_FK="

alter table address add foreign key fk_addr_co_id ( addr_co_id) references country ( co_id );
alter table customer add foreign key fk_c_addr_id ( c_addr_id ) references address ( addr_id );
alter table item add foreign key fk_i_a_id ( i_a_id ) references author ( a_id );
alter table orders add foreign key fk_o_c_id ( o_c_id ) references customer ( c_id );
alter table orders add foreign key fk_o_bill_addr_id ( o_bill_addr_id ) references address ( addr_id );
alter table orders add foreign key fk_o_ship_addr_id ( o_ship_addr_id ) references address ( addr_id );
alter table order_line add foreign key fk_line_ol_i_id ( ol_i_id ) references item ( i_id );
alter table order_line add foreign key fk_line_ol_o_id ( ol_o_id ) references orders ( o_id );
alter table cc_xacts add foreign key fk_cx_o_id ( cx_o_id ) references orders ( o_id );
alter table cc_xacts add foreign key fk_cx_co_id ( cx_co_id ) references country ( co_id );

"

CREATE_INDEXES="

create index i_i_subject on item (i_subject asc);
create index i_i_a_id on item (i_a_id asc);
create index i_address_table on address (addr_street1, addr_street2, addr_city, addr_state, addr_zip, addr_co_id);
create index i_c_uname on customer (c_uname asc);
create index i_o_c_id on orders (o_c_id asc);

-- create index i_i_title on item (i_title asc);
-- create index i_a_lname on author (a_lname asc);

"
CREATE_SEQUENCE="DROP TABLE IF EXISTS \`custid\`;
CREATE TABLE \`custid\` ( \`id\` int(11) NOT NULL ) ENGINE=MyISAM DEFAULT CHARSET=latin1;
DROP TABLE IF EXISTS \`addrid\`;
CREATE TABLE \`addrid\` ( \`id\` int(11) NOT NULL ) ENGINE=MyISAM DEFAULT CHARSET=latin1;
DROP TABLE IF EXISTS \`scid\`;
CREATE TABLE \`scid\` ( \`id\` int(11) NOT NULL ) ENGINE=MyISAM DEFAULT CHARSET=latin1;

INSERT INTO custid SELECT MAX(c_id) FROM customer;
INSERT INTO addrid SELECT MAX(addr_id) FROM address;
INSERT INTO scid SELECT MAX(o_id) FROM orders;
"

date
echo "drop database"
$MYSQL $MYSQL_ARGS -e "$DROP_DB"

date
echo "create database"
$MYSQL $MYSQL_ARGS -e "$CREATE_DB"

date
echo "create tables"
$MYSQL $MYSQL_ARGS -e "$CREATE_TABLES" ${tpcw_database}

date
echo "load database"
$MYSQL $MYSQL_ARGS -e "$LOAD_DB" ${tpcw_database}

date
echo "create foreign keys"
$MYSQL $MYSQL_ARGS -e "$CREATE_FK" ${tpcw_database}

date
echo "create indexes"
$MYSQL $MYSQL_ARGS -e "$CREATE_INDEXES" ${tpcw_database}

date
echo "create sequenses"
$MYSQL $MYSQL_ARGS -e "$CREATE_SEQUENCE" ${tpcw_database}
date
