#!/bin/sh

#export ORACLE_SID=DBT1

sqlplus -S dbt/dbt <<_EOF_
create table author ( a_id number(10) not null, a_fname varchar2(20), a_lname varchar2(20), a_mname varchar2(20), a_dob date, a_bio varchar2(500),CONSTRAINT pkey_author PRIMARY KEY(a_id) );
create table country ( co_id number(4) not null, co_name varchar2(50), co_exchange number(12, 6), co_currency varchar2(18),CONSTRAINT pkey_country  PRIMARY KEY(co_id) );
create table address ( addr_id number(10) not null, addr_street1 varchar2(40), addr_street2 varchar2(40), addr_city varchar2(30), addr_state varchar2(20), addr_zip varchar2(10), addr_co_id number(4),CONSTRAINT pkey_address  PRIMARY KEY(addr_id) );
create table customer ( c_id number(10) not null, c_uname varchar2(20), c_passwd varchar2(20), c_fname varchar2(15), c_lname varchar2(15), c_addr_id number(10), c_phone varchar2(16), c_email varchar2(50), c_since date, c_last_visit date, c_login timestamp, c_expiration timestamp, c_discount number(5, 2), c_balance number(17, 2), c_ytd_pmt number(17, 2), c_birthdate date, c_data varchar2(500),CONSTRAINT pkey_customer PRIMARY KEY(c_id) );
create table item ( i_id number(10) not null, i_title varchar2(60), i_a_id number(10), i_pub_date date, i_publisher varchar2(60), i_subject varchar2(60), i_desc varchar2(500), i_related1 number(10), i_related2 number(10), i_related3 number(10), i_related4 number(10), i_related5 number(10), i_thumbnail number(8), i_image number(8), i_srp number(17, 2), i_cost number(17, 2), i_avail date, i_stock number(4), i_isbn char(13), i_page number(4), i_backing varchar2(15), i_dimensions varchar2(25),CONSTRAINT pkey_item    PRIMARY KEY(i_id) );
create table orders ( o_id number(10) not null, o_c_id number(10), o_date timestamp, o_sub_total number(17, 2), o_tax number(17, 2), o_total number(17, 2), o_ship_type varchar2(10), o_ship_date timestamp, o_bill_addr_id number(10), o_ship_addr_id number(10), o_status varchar2(15),CONSTRAINT pkey_orders PRIMARY KEY(o_id) );
create table order_line ( ol_id number(3) not null, ol_o_id number(10) not null, ol_i_id number(10), ol_qty number(3), ol_discount number(5, 2), ol_comments varchar2(100),CONSTRAINT pkey_order_line PRIMARY KEY(ol_o_id, ol_id) );
create table cc_xacts ( cx_o_id number(10) not null, cx_type varchar2(10), cx_num number(16), cx_name varchar2(31), cx_expiry date, cx_auth_id char(15), cx_xact_amt number(17, 2), cx_xact_date timestamp, cx_co_id number(4),CONSTRAINT pkey_cc_xacts PRIMARY KEY(cx_o_id) );
create table shopping_cart ( sc_id number(10) not null, sc_c_id number(10), sc_date timestamp, sc_sub_total number(17, 2), sc_tax number(17, 2), sc_ship_cost number(17, 2), sc_total number(17, 2), sc_c_fname varchar2(15), sc_c_lname varchar2(15), sc_c_discount number(5, 2),CONSTRAINT pkey_shopping_cart PRIMARY KEY(sc_id) );
create table shopping_cart_line ( scl_sc_id number(10) not null, scl_i_id number(10) not null, scl_qty number(3), scl_cost number(17, 2), scl_srp number(17, 2), scl_title varchar2(60), scl_backing varchar2(15),CONSTRAINT pkey_sc_line PRIMARY KEY(scl_sc_id, scl_i_id) );
_EOF_
