#!/bin/sh
###
# 		dont start script as root!
#		--------------------------
#
# create example database TST with (only for seperated packages - sapdb-ind, sapdb-srv, sapdb-testdb):
#   - 20 MB data devspace and 8 MB log devspace
#   - demo database user test (with password test)
###


id=`id | sed s/\(.*// | sed s/uid=//`

if [ "$id" = "0" ]; then
	echo "dont start script as root"
	exit 1
fi 

#export PATH=/opt/sapdb/indep_prog/bin:$PATH
#set -x

# start remote communication server
echo "start communication server..."
x_server start >/dev/null 2>&1

# dir where the database system files are
SYS_DIR="$HOME/dbt1"

# stop and drop probably existing demo database
echo "stop and drop existing $SID1..."
dbmcli -d $SID1 -u dbm,dbm db_offline >/dev/null 2>&1
dbmcli -d $SID1 -u dbm,dbm db_drop >/dev/null 2>&1

# create new demo database
echo "create database $SID1..."
_o=`dbmcli -s db_create $SID1 dbm,dbm 2>&1`
_test=`echo $_o | grep OK`
if [ "$_test" = "" ]; then
	echo "create $SID1 failed: $_o"
	exit 1
fi

# create directory where to put the database files
mkdir -p $SYS_DIR/$SID1


# setup database parameters
#devspace definition
# startup database
# initialize database files
# util_activate -> db_activate for MaxDB
# load database system tables
#param_addvolume 1 LOG  LOG_001  F  1200000
#param_addvolume 1 DATA DAT_001  F  6000000
_o=`cat <<EOF | dbmcli -d $SID1 -u dbm,dbm 2>&1
param_rmfile
param_startsession
param_init
param_put MAXUSERTASKS 200
param_checkall
param_commitsession
param_addvolume 1 LOG  LOG_001  F  160000
param_addvolume 1 DATA DAT_001  F  800000
db_admin
db_activate dba,dba
load_systab -ud domain
EOF`
_test=`echo $_o | grep OK`
if [ "$_test" = "" ]; then
        echo "set parameters failed: $_o"
        exit 1
fi

# set log auto overwrite
echo "set log auto overwrite..."
_o=`cat <<EOF | dbmcli -d $SID1 -u dbm,dbm 2>&1
util_execute set log auto overwrite on
EOF`
_test=`echo $_o | grep OK`
if [ "$_test" = "" ]; then
        echo "set log auto overwrite failed: $_o"
        exit 1
fi

# create database demo user
echo "create database demo user..."
_o=`cat <<EOF | dbmcli -d $SID1 -u dba,dba 2>&1
db_start
db_online
sql_connect dba,dba
sql_execute CREATE USER dbt PASSWORD dbt DBA NOT EXCLUSIVE
EOF`
_test=`echo $_o | grep OK`
if [ "$_test" = "" ]; then
        echo "create db user failed: $_o"
        exit 1
fi

exit 0
